package arithmetic;

import java.util.ArrayList;

public class ArithmeticVisitor extends VisitorAdaptor {

	ArrayList<Integer> stack=new ArrayList<Integer>();

	public void visit(Constant constant) {
		stack.add(constant.getVal());
	}

	public void visit(Multiplication multiplication) {
		int op1=stack.remove(stack.size()-1);
		int op2=stack.remove(stack.size()-1);
		if(multiplication.getMulop().equals("mul")) {
			stack.add(op1*op2);
		} else {
			stack.add(op1/op2);
		}
	}

	public void visit(Addition addition) {
		int op1=stack.remove(stack.size()-1);
		int op2=stack.remove(stack.size()-1);
		if(addition.getAddop().equals("add")) {
			stack.add(op1+op2);
		} else {
			stack.add(op1-op2);
		}
	}

	public int getResult() {
		return stack.get(0);
	}
}